﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace PaymentMethodSample
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window, INotifyPropertyChanged
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = this;

            DoStuff();
        }

        private void DoStuff()
        {
            ActivePaymentMethods = new ObservableCollection<PaymentMethod>();
            AllPayments = new ObservableCollection<BulkPayment>();

            //Create some combo box selection possibilities
            ActivePaymentMethods.Add(new PaymentMethod(1, "Check", true));
            ActivePaymentMethods.Add(new PaymentMethod(2, "EFT", true));
            ActivePaymentMethods.Add(new PaymentMethod(3, "PayPal", true));
            ActivePaymentMethods.Add(new PaymentMethod(4, "Credit Card", true));

            //Create a couple of bulk payments

            PaymentMethod check = new PaymentMethod(1, "Check", true);
            PaymentMethod eft = new PaymentMethod(2, "EFT", true);
            PaymentMethod payPal = new PaymentMethod(3, "PayPal", true);
            PaymentMethod card = new PaymentMethod(4, "Credit Card", true);

            
            //IG  I added the value of the BulkPaymenMethodID based on the PaymentMethod that you in the BulkPayment

            AllPayments.Add(new BulkPayment(1, 1, "Vendor", 1, 1, DateTime.Today, 1, check, "1", 10.00m, "1"));
            AllPayments.Add(new BulkPayment(2, 2, "Employer", 1, 1, DateTime.Today, 1, check, "1", 20.00m, "1"));
            AllPayments.Add(new BulkPayment(3, 2, "Employer", 1, 1, DateTime.Today, 2, eft, "1", 30.00m, "1"));
            AllPayments.Add(new BulkPayment(4, 1, "Vendor", 1, 1, DateTime.Today, 2, eft, "1", 40.00m, "1"));
            AllPayments.Add(new BulkPayment(5, 1, "Vendor", 1, 1, DateTime.Today, 1, check, "1", 50.00m, "1"));
            AllPayments.Add(new BulkPayment(6, 2, "Employer", 1, 1, DateTime.Today, 3, payPal, "1", 60.00m, "1"));


        }

        private ObservableCollection<PaymentMethod> _activePaymentMethods;
        public ObservableCollection<PaymentMethod> ActivePaymentMethods
        {
            get { return _activePaymentMethods; }
            set
            {
                _activePaymentMethods = value;
                NotifyPropertyChanged("ActivePaymentMethods");
            }
        }


        private ObservableCollection<BulkPayment> _allPayments;
        public ObservableCollection<BulkPayment> AllPayments
        {
            get { return _allPayments; }
            set
            {
                _allPayments = value;
                NotifyPropertyChanged("AllPayments");
            }
        }


        #region Prop

        public event PropertyChangedEventHandler PropertyChanged;


        private void NotifyPropertyChanged(string info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }

        #endregion

    }
}
